

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER


//#define Board_V2G_HARDWARE_POLLING  
// SCHALTET Software fr AUX am Board V2G ein

#define TIMER_TICK_USED
#define UART_USE_ENABLED
//#define EEPROM_USED
//#define ADC_USED_ENABLED

#define TEXT_SERVICE_USE_ENABLED
#define ENDORDER_CMD_ECHO_ENABLED
#define USED_HEX_CONVERSION	1

#define USE_ERROR_FLAG

/*
Jedes Port hat drei Register
DDxN
PORTXn
PINxn
IF PortX ist INPUT an PORTX= set to 1, PullUP IS ENABLED
*/


/*
Text verbraucht Speicher
Statt Pointer geht evtl auch diese Form
TESTEN !!!
const uint8_t MCA_CRLFSTR[] __attribute__ ((section (".text"))) = {13,10,0};
//Versus diesr Form, die Speicher verbraucht !! ROCKEN ALS EINFGESTRING DEFINIERT.
#define MCA_CRLFSTR (const char){CR,LF,0}  //redefined 

*/


//For compatibility for OLDER Compilers
//#define	sbi(sfr, bit)   (_SFR_BYTE(sfr) |= _BV(bit))
//#define	cbi(sfr, bit)   (_SFR_BYTE(sfr) &= ~_BV(bit))

#define BIT_0	0x01
#define BIT_1	0x02
#define BIT_2	0x04
#define BIT_3	0x08
#define BIT_4	0x10
#define BIT_5	0x20
#define BIT_6	0x40
#define BIT_7	0x80


#define STRMAX 64
#define NUMMAX 32
#define RX_STRMAX 32
#define COMAMNDSIZEMAX  32

#define DELIMITER		','
#define DELIMITERSTR	","

#define BYTE_LIMIT 255				//uint8_t					uint8_t
#define WORD_LIMIT 65535			//unsigned short				uint16_t
#define DWORD_LIMIT 4294967295UL	//unsigned long					uint32_t
//Wird benutz um T2 berlauf zu berwachen !!
#define BEFORE_DWORD_LIMIT 429496000UL	//unsigned long					uint32_t
#define QWORD_LIMIT 18446744073709551615ULL	//unsigned long long 	uint64_t

#define LOW_NIPPEL_MASK		0x0F
#define HIGH_NIPPEL_MASK	0xF0


//TYPEN DEKLARATION
typedef struct
	{
	char ucaCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
//uint8_t ucCmdID;
	}COMMAND_TYPE;

// Hardwareassignment
//F_CPU  in makefile !!!
#define UART_BAUD_RATE	9600	/* 9600 baud */
//#define UART_BAUD_RATE	19200
//#define UART_BAUD_RATE	57600

#define PULS_PER_10TEL_SEc	25
#define PULS_1000MS_Tick	244
#define PULS_500MS_Tick		122
#define PULS_250MS_TICK		61
#define PULS_100MS_TICK		25
#define PULS_50MS_TICK		13
	
#define SYSCLK_256	(SYSCLK / 256) // =  62500 //z.B.Timer2 berlauf / 256  / Teilerfaktor

#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));


//PORTD TX/RX ERST MAL FR  FLAGS
#define PD0_RX_BIT	0x01	//PIN2
#define PD1_TX_BIT	0x02	//PIN3

//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
//PORT_ASSIGMNEMTS
#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES

#define ASC_CR	13
#define ASC_LF	10
#define ASC_DELIMITER	','

#define FLOAT_OVERFLOW_2_19 0x7FFFFUL //= liegt VOR berlauf !!! 524287	Um es Vor!! DEM BERLAUF ABZUFANGEN
#define HALF_FLOAT_OVERFLOW 0x3FFFFUL

//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORTA  	//1=OUT 6BIT
//1=OUT
#define PORTA_DDRX_OUTMASK		0X00	//3 und 4 auf INPUT
#define PORTA_PRESET_PULLMASK	0x00	//Ohne Pullup

//CHECK PUD = PULLUPDISSABLE in SFIOR 
//PORT B  	//1=OUT 6BIT
//1=OUT
#define PORTB_DDRX_OUTMASK		0X00			
#define PORTB_PRESET_PULLMASK	0X00	//Ohne Pullup	

//PORT C 	TWI //1=OUT  0 = IN  6BIT
//STARTWERTE
#define PORTC_DDRX_OUTMASK		0x00
#define PORTC_PRESET_PULLMASK	0X00	//Ohne Pullup

//PORT D	//1=OUT 8 BIT 
//TX/RX & zusatzhardware
#define PORTD_DDRX_OUTMASK		0b00000010
#define PORTD_PRESET_PULLMASK	0b00000010	//ohnePullup


//BOARD V2G OWN_BREW EVALUIERUNGS BOARD...
#define BOARD_AUX_PORT_OUT			PORTD
#define BOARD_AUX_PORT_IN			PIND
#define PORTD_DDRX_BOARD_V2G_AUX_MSK	0b00011010	// DIRECTION
#define PORTD_BOARD_V2G_AUX_PULLUP_MSK	0b11100010  // PULLUP

//Aufzaehlbezeichner
#define RX_BITNR	PD0 //0
#define TX_BITNR	PD1	//1
#define LED1_BITNR	PD3	//2
#define LED2_BITNR	PD4	//3
#define KEY1_BITNR	PD5	//4
#define KEY2_BITNR	PD6	//5
#define KEY3_BITNR	PD7	//6

//VERSUS
//Byte-Masken sind die "direkte" binaere Umsetzung von Aufzaehlbezeichnern ( 0..7 )
#define LED1_BIT    0x08	//0000 1000
#define LED2_BIT    0x10	//0001 0000
#define KEY1_BIT    0x20   	//0010 0000
#define KEY2_BIT    0x40	//0100 0000
#define KEY3_BIT    0x80	//1000 0000

//------ MAKROS zur Fehlerarmen/sicheren und gut lesbaren, einfachen Programmierung
#define SET_LED1() ( BOARD_AUX_PORT_OUT |= LED1_BIT)
#define CLR_LED1() ( BOARD_AUX_PORT_OUT &= ~LED1_BIT)

#define SET_LED2() ( BOARD_AUX_PORT_OUT |= LED2_BIT)
#define CLR_LED2() ( BOARD_AUX_PORT_OUT &= ~LED2_BIT)

#define READ_KEY1()	(BOARD_AUX_PORT_IN & KEY1_BIT)
#define READ_KEY2() (BOARD_AUX_PORT_IN & KEY2_BIT)
#define READ_KEY3() (BOARD_AUX_PORT_IN & KEY3_BIT)

#endif  //MAIN_HEADER
